VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Append Test"
   ClientHeight    =   5115
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3750
   LinkTopic       =   "Form1"
   ScaleHeight     =   5115
   ScaleWidth      =   3750
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Fast"
      Height          =   510
      Left            =   195
      TabIndex        =   3
      Top             =   810
      Width           =   1395
   End
   Begin VB.TextBox Text2 
      Height          =   390
      Left            =   1755
      TabIndex        =   2
      Top             =   885
      Width           =   1620
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Slow"
      Height          =   510
      Left            =   180
      TabIndex        =   1
      Top             =   150
      Width           =   1395
   End
   Begin VB.TextBox Text1 
      Height          =   390
      Left            =   1770
      TabIndex        =   0
      Top             =   210
      Width           =   1620
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   3555
      Left            =   90
      TabIndex        =   4
      Top             =   1515
      Width           =   3600
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()
Label1.Caption = ""
u% = DoEvents
tim& = GetTickCount
'**************
' slow version
'**************
'note the second & is just to prove that joining to strings is
'not inherently slow, only adding a string to itself g$ = g$ & extra

For a% = 1 To 5000
    g$ = g$ & "str" & "g "
Next

'****
Text1.Text = GetTickCount - tim&
Label1.Caption = g$
End Sub

Private Sub Command2_Click()
Label1.Caption = ""
u% = DoEvents
tim& = GetTickCount
Dim pos&
Dim src As String
Dim des As String
'****************
' Fast Version
'****************
'Allocates a big string, then copies the smaller strings into it.
'this means that VB does not need to perform the expensive
'dynamic realocation of string memory!

des = Space$(10000)

For a% = 1 To 5000
    src = "str" & "g "
    If pos& + LenB(src) > LenB(des) Then des = des & Space$(10000)
    CopyMemory ByVal StrPtr(des) + pos&, ByVal StrPtr(src), LenB(src)
    pos& = pos& + LenB(src)
Next

des = Left$(des, pos& \ 2) 'trim back to size
'**********
Text2.Text = GetTickCount - tim&
Label1.Caption = des
End Sub
